#include <iostream>
#include <unordered_map>
#include <string>

struct Person {
    std::string name;
    int age;

    bool operator==(const Person& other) const {
        return name == other.name && age == other.age;
    }
};

// Custom hash function for Person
struct PersonHash {
    std::size_t operator()(const Person& p) const {
        return std::hash<std::string>()(p.name) ^ std::hash<int>()(p.age);
    }
};

int main() {
    std::unordered_map<Person, std::string, PersonHash> personDescriptions;

    personDescriptions[{"Alice", 30}] = "Software Engineer";
    personDescriptions[{"Bob", 25}] = "Data Analyst";
    personDescriptions[{"Charlie", 35}] = "Project Manager";

    for (const auto& pair : personDescriptions) {
        std::cout << pair.first.name << " (Age " << pair.first.age << "): " 
                  << pair.second << std::endl;
    }

    return 0;
}
