#include <iostream>
#include <unordered_map>
#include <string>

int main() {
    std::unordered_map<std::string, int> wordCount = {
        {"apple", 3}, {"banana", 2}, {"cherry", 5},
        {"date", 1}, {"elderberry", 4}, {"fig", 3}
    };

    // Print bucket information
    std::cout << "Bucket count: " << wordCount.bucket_count() << std::endl;
    std::cout << "Max bucket count: " << wordCount.max_bucket_count() << std::endl;
    std::cout << "Load factor: " << wordCount.load_factor() << std::endl;
    std::cout << "Max load factor: " << wordCount.max_load_factor() << std::endl;

    // Print contents of each bucket
    for (size_t i = 0; i < wordCount.bucket_count(); ++i) {
        std::cout << "Bucket " << i << " contains:";
        for (auto it = wordCount.begin(i); it != wordCount.end(i); ++it) {
            std::cout << " " << it->first << "(" << it->second << ")";
        }
        std::cout << std::endl;
    }

    // Find which bucket an element is in
    std::string search = "cherry";
    size_t bucket = wordCount.bucket(search);
    std::cout << "'" << search << "' is in bucket " << bucket << std::endl;

    // Rehash the container
    std::cout << "\nRehashing to 20 buckets..." << std::endl;
    wordCount.rehash(20);
    std::cout << "New bucket count: " << wordCount.bucket_count() << std::endl;

    return 0;
}
